package com.unipi.talepis.singletons;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

public class AttackToEager1 {
    public static void main(String[] args) {
        SingletonEager11 e1 = SingletonEager11.getInstance();
        SingletonEager11 e2 = null;

        try {
            Constructor constructor = SingletonEager11.class.getDeclaredConstructor();
            constructor.setAccessible(true);
            e2 = (SingletonEager11) constructor.newInstance();
        } catch (NoSuchMethodException | IllegalAccessException | InstantiationException | InvocationTargetException e) {
            e.printStackTrace();
        }
        System.out.println(e1.hashCode());
        System.out.println(e2.hashCode());

        SingletonEager11v2 ev1 = SingletonEager11v2.getInstance();
        SingletonEager11v2 ev2 = null;

        try {
            Constructor constructor = SingletonEager11v2.class.getDeclaredConstructor();
            constructor.setAccessible(true);
            ev2 = (SingletonEager11v2) constructor.newInstance();
        } catch (NoSuchMethodException | IllegalAccessException | InstantiationException | InvocationTargetException e) {
            e.printStackTrace();
        }
        System.out.println(ev1.hashCode());
        System.out.println(ev2.hashCode());
    }
}
